////////////////////////////////////////////////
// Copyright Thomas Nilsson                   //
//                                            //
////////////////////////////////////////////////
//Overall mesh i gmsh: 1.0

lambda=23.5;
//Intersection between inner box and bom
cl_bom=0.5;
Point(14001) = {4.865, 3, 0, cl_bom};
Point(14002) = {5.09, 3, 0, cl_bom};
Point(14003) = {4.865, 3, 0.1582113010464356, cl_bom};
Point(14004) = {5.09, 3, 0.1582113010464356, cl_bom};
Line(14005) = {14001, 14003};
Line(14006) = {14003, 14004};
Line(14007) = {14004, 14002};
Line(14008) = {14002, 14001};
Line Loop(14009) = {14006, 14007, 14008, 14005};
Plane Surface (14010)={14009};

//Outer box (Boundary)
X=2;
//2*Lambda_d away from any part of SC
cl_out=lambda/3;
Point(2009) = {-X*lambda, -2-X*lambda, -2-X*lambda, cl_out};
Point(2010) = {-X*lambda, -2-X*lambda, 2+X*lambda, cl_out};
Point(2011) = {-X*lambda, 12+X*lambda, 2+X*lambda, cl_out};
Point(2012) = {-X*lambda, 12+X*lambda, -2-X*lambda, cl_out};
Point(2013) = {6+X*lambda, 12+X*lambda, -2-X*lambda, cl_out};
Point(2014) = {6+X*lambda, 12+X*lambda, 2+X*lambda, cl_out};
Point(2015) = {6+X*lambda, -2-X*lambda, 2+X*lambda, cl_out};
Point(2016) = {6+X*lambda, -2-X*lambda, -2-X*lambda, cl_out};

//Interm. box
//2.35m away from any part of SC (lambda/10)
cl_int=0.8;
Point(14005) = {6+lambda/10, 12+lambda/10, -2-lambda/10, cl_int};
Point(14006) = {-lambda/10, 12+lambda/10, -2-lambda/10, cl_int};
Point(14010) = {-lambda/10, 12+lambda/10, 2+lambda/10, cl_int};
Point(14014) = {6+lambda/10, 12+lambda/10, 2+lambda/10, cl_int};
Point(14026) = {-lambda/10, -2-lambda/10, 2+lambda/10, cl_int};
Point(14030) = {-lambda/10, -2-lambda/10, -2-lambda/10, cl_int};
Point(14038) = {6+lambda/10, -2-lambda/10, -2-lambda/10, cl_int};
Point(14042) = {6+lambda/10, -2-lambda/10, 2+lambda/10, cl_int};

//Inner box
//1 m away from most of SC
cl_inn=0.4;
Point(5007) = {7, 3, -3, cl_inn};
Point(5008) = {-1, 3, -3, cl_inn};
Point(5012) = {-1, 3, 3, cl_inn};
Point(5016) = {7, 3, 3, cl_inn};
Point(5028) = {-1, -3, -3, cl_inn};
Point(5032) = {7, -3, -3, cl_inn};
Point(5044) = {7, -3, 3, cl_inn};
Point(5048) = {-1, -3, 3, cl_inn};

//Outer mesh bom for LP
cl_out_LP=0.03;
r_lp_bom=0.00953;
Point(7001) = {5.01, 0, 2.734, cl_out_LP};
Point(7002) = {5.01+4*r_lp_bom, 0, 2.734, cl_out_LP};
Point(7003) = {5.01, 4*r_lp_bom, 2.734, cl_out_LP};
Point(7004) = {5.01, -4*r_lp_bom, 2.734, cl_out_LP};
Point(7005) = {5.01-4*r_lp_bom, 0, 2.734, cl_out_LP};
Point(7006) = {5.01, -4*r_lp_bom, 1.15, 2*cl_out_LP};
Point(7007) = {5.01, 0, 1.15, 2*cl_out_LP};
Point(7008) = {5.01-4*r_lp_bom, 0, 1.15, 2*cl_out_LP};
Point(7009) = {5.01, 4*r_lp_bom, 1.15, 2*cl_out_LP};
Point(7010) = {5.01+4*r_lp_bom, 0, 1.15, 2*cl_out_LP};

//Actuall bom for the LP
cl_in_LP=0.02;
Point(7011) = {5.01-r_lp_bom, 0, 2.491, cl_in_LP};
Point(7012) = {5.01-r_lp_bom, 0, 1.18, 2*cl_in_LP};
Point(7016) = {5.01, 0, 1.18, 2*cl_in_LP};
Point(7017) = {5.01, r_lp_bom, 1.18, 2*cl_in_LP};
Point(7021) = {5.01, r_lp_bom, 2.491, cl_in_LP};
Point(7025) = {5.01, 0, 2.491, cl_in_LP};
Point(7029) = {5.01, -r_lp_bom, 1.18, 2*cl_in_LP};
Point(7041) = {5.01+r_lp_bom, 0, 1.18, 2*cl_in_LP};
Point(7050) = {5.01, -r_lp_bom, 2.491, cl_in_LP};
Point(7073) = {5.01+r_lp_bom, 0, 2.491, cl_in_LP};

//Bom and mesh bom for the LP
Circle(7001) = {7005, 7001, 7003};
Circle(7002) = {7003, 7001, 7002};
Circle(7003) = {7002, 7001, 7004};
Circle(7004) = {7004, 7001, 7005};
Circle(7005) = {7006, 7007, 7008};
Circle(7006) = {7008, 7007, 7009};
Circle(7007) = {7009, 7007, 7010};
Circle(7008) = {7010, 7007, 7006};
Line(7009) = {7006, 7004};
Line(7010) = {7005, 7008};
Line(7011) = {7009, 7003};
Line(7012) = {7010, 7002};
Line(7014) = {7011, 7012};
Circle(7015) = {7012, 7016, 7017};
Line(7016) = {7017, 7021};
Circle(7017) = {7021, 7025, 7011};
Circle(7019) = {7029, 7016, 7012};
Circle(7021) = {7017, 7016, 7041};
Circle(7022) = {7041, 7016, 7029};
Line(7024) = {7029, 7050};
Circle(7025) = {7050, 7025, 7011};
Circle(7030) = {7050, 7025, 7073};
Line(7031) = {7073, 7041};
Circle(7035) = {7021, 7025, 7073};
Line Loop(7001) = {7004, 7001, 7002, 7003};
Plane Surface(7001) = {7001};
Line Loop(7002) = {7005, 7006, 7007, 7008};
Plane Surface(7002) = {7002};
Line Loop(7003) = {7009, -7003, -7012, 7008};
Ruled Surface(7003) = {7003};
Line Loop(7004) = {7009, 7004, 7010, -7005};
Ruled Surface(7004) = {7004};
Line Loop(7005) = {7010, 7006, 7011, -7001};
Ruled Surface(7005) = {7005};
Line Loop(7006) = {7011, 7002, -7012, -7007};
Ruled Surface(7006) = {7006};
Line Loop(7013) = {7014, 7015, 7016, 7017};
Ruled Surface(7013) = {7013};
Line Loop(7018) = {7019, 7015, 7021, 7022};
Plane Surface(7018) = {7018};
Line Loop(7023) = {7024, 7025, 7014, -7019};
Ruled Surface(7023) = {7023};
Line Loop(7028) = {7024, 7030, 7031, 7022};
Ruled Surface(7028) = {7028};
Line Loop(7033) = {7016, 7035, 7031, -7021};
Ruled Surface(7033) = {7033};
Line Loop(7038) = {7025, -7017, 7035, -7030};
Plane Surface(7038) = {7038};
Surface Loop(7039) = {7005, 7004, 7003, 7001, 7006, 7002};
Surface Loop(7040) = {7038, 7023, 7028, 7033, 7013, 7018};
Volume(7001) = {7039, 7040};

//SC
cl_sc=0.20;
Point(3001) = {0, 0, 0, cl_sc};
Point(3002) = {3.6, 0, 0, cl_sc};
Point(3003) = {4.415, 0, 0, cl_sc};
Point(3004) = {4.865, 0, 0, cl_sc};
Point(3005) = {5.09, 0, 0, cl_sc};
Point(3006) = {0, 0.9, 0, cl_sc};
Point(3007) = {3.6, 0.9, 0, cl_sc};
Point(3008) = {4.415, 1.125, 0, cl_sc};
Point(3009) = {4.865, 1.125, 0, cl_sc};
Point(3010) = {5.09, 1.125, 0, cl_sc};
Point(3011) = {4.865, 0, 1.125, cl_sc};
Point(3012) = {5.09, 0, 1.125, cl_sc};
Point(3015) = {4.415, 0, 1.125, cl_sc};
Point(3019) = {3.6, 0, 0.9, cl_sc};
Point(3023) = {0, 0, 0.9, cl_sc};
Point(3024) = {4.865, -1.125, 0, cl_sc};
Point(3025) = {5.09, -1.125, 0, cl_sc};
Point(3028) = {4.415, -1.125, 0, cl_sc};
Point(3032) = {3.6, -0.9, 0, cl_sc};
Point(3036) = {0, -0.9, 0, cl_sc};
Point(3037) = {4.865, 0, -1.125, cl_sc};
Point(3038) = {5.09, 0, -1.125, cl_sc};
Point(3041) = {4.415, 0, -1.125, cl_sc};
Point(3045) = {3.6, 0, -0.9, cl_sc};
Point(3049) = {0, 0, -0.9, cl_sc};
Point(3050) = {4.865, 1.113819637203975, 0.1582113010464356, cl_sc};
Point(3051) = {5.09, 1.113819637203975, 0.1582113010464356, cl_sc};
Point(3054) = {4.415, 1.113819637203975, 0.1582113010464356, cl_sc};
Point(3058) = {3.6, 0.8910557097631799, 0.1265690408371485, cl_sc};
Point(3062) = {0, 0.8910557097631799, 0.1265690408371485, cl_sc};
Point(3063) = {4.865, 12.125, 0, cl_int};
Point(3064) = {5.09, 12.125, 0, cl_int};
Point(3065) = {4.865, 12.125, 0.1582113010464356, cl_int};
Point(3066) = {5.09, 12.125, 0.1582113010464356, cl_int};
Point(5001) = {6, 0, 0, cl_sc};
Point(5002) = {6, 2, 0, cl_sc};
Point(5003) = {6, -2, 0, cl_sc};
Point(5004) = {6, 0, 2, cl_sc};
Point(5005) = {6, 0, -2, cl_sc};
Point(5006) = {5.19, 0, 0, cl_sc};

//Line outer box
Line(2013) = {2012, 2011};
Line(2014) = {2011, 2014};
Line(2015) = {2014, 2013};
Line(2016) = {2013, 2012};
Line(2017) = {2012, 2009};
Line(2018) = {2009, 2010};
Line(2019) = {2010, 2011};
Line(2020) = {2009, 2016};
Line(2021) = {2016, 2015};
Line(2022) = {2015, 2014};
Line(2023) = {2013, 2016};
Line(2024) = {2015, 2010};


//Line SC
Line(3001) = {3006, 3007};
Line(3002) = {3007, 3008};
Line(3003) = {3008, 3009};
Line(3004) = {3009, 3010};
Line(3005) = {3011, 3012};
Line(3006) = {3015, 3011};
Line(3007) = {3019, 3015};
Line(3008) = {3023, 3019};
Line(3009) = {3024, 3025};
Line(3010) = {3028, 3024};
Line(3011) = {3032, 3028};
Line(3012) = {3036, 3032};
Line(3013) = {3037, 3038};
Line(3014) = {3041, 3037};
Line(3015) = {3045, 3041};
Line(3016) = {3049, 3045};
Line(3017) = {3050, 3051};
Line(3018) = {3054, 3050};
Line(3019) = {3058, 3054};
Line(3020) = {3062, 3058};
Circle(3021) = {3006, 3001, 3049};
Circle(3022) = {3049, 3001, 3036};
Circle(3023) = {3036, 3001, 3023};
Circle(3024) = {3023, 3001, 3062};
Circle(3025) = {3062, 3001, 3006};
Circle(3026) = {3007, 3002, 3045};
Circle(3027) = {3045, 3002, 3032};
Circle(3028) = {3032, 3002, 3019};
Circle(3029) = {3019, 3002, 3058};
Circle(3030) = {3058, 3002, 3007};
Circle(3031) = {3008, 3003, 3041};
Circle(3032) = {3041, 3003, 3028};
Circle(3033) = {3028, 3003, 3015};
Circle(3034) = {3015, 3003, 3054};
Circle(3035) = {3054, 3003, 3008};
Circle(3036) = {3009, 3004, 3037};
Circle(3037) = {3037, 3004, 3024};
Circle(3038) = {3024, 3004, 3011};
Circle(3039) = {3011, 3004, 3050};
Circle(3040) = {3050, 3004, 3009};
Circle(3041) = {3010, 3005, 3038};
Circle(3042) = {3038, 3005, 3025};
Circle(3043) = {3025, 3005, 3012};
Circle(3044) = {3012, 3005, 3051};
Circle(3045) = {3051, 3005, 3010};
Line(3090) = {3063, 3064};
Line(3091) = {3064, 3066};
Line(3092) = {3066, 3065};
Line(3093) = {3065, 3063};
Line(3094) = {3010, 14002};
Line(3095) = {14001, 3009};
Line(3096) = {3050, 14003};
Line(3097) = {14004, 3051};
Circle(5001) = {5002, 5001, 5005};
Circle(5002) = {5005, 5001, 5003};
Circle(5003) = {5003, 5001, 5004};
Circle(5004) = {5004, 5001, 5002};
Ellipse(5005) = {5005, 5001, 5006, 5006};
Ellipse(5006) = {5002, 5001, 5006, 5006};
Ellipse(5007) = {5004, 5001, 5006, 5006};
Ellipse(5008) = {5003, 5001, 5006, 5006};
Line(5025) = {5007, 5008};
Line(5026) = {5008, 5012};
Line(5027) = {5012, 5016};
Line(5028) = {5016, 5007};
Line(5031) = {5008, 5028};
Line(5032) = {5028, 5032};
Line(5033) = {5032, 5007};
Line(5036) = {5032, 5044};
Line(5037) = {5044, 5048};
Line(5038) = {5048, 5028};
Line(5041) = {5016, 5044};
Line(5043) = {5048, 5012};


Line(90003) = {3066, 14004};
Line(90004) = {3064, 14002};
Line(90005) = {3063, 14001};
Line(90006) = {3065, 14003};
Line(90028) = {14005, 14006};
Line(90029) = {14006, 14010};
Line(90030) = {14010, 14014};
Line(90031) = {14014, 14005};
Line(90034) = {14010, 14026};
Line(90035) = {14026, 14030};
Line(90036) = {14030, 14006};
Line(90038) = {14030, 14038};
Line(90039) = {14038, 14042};
Line(90040) = {14042, 14026};
Line(90044) = {14005, 14038};
Line(90046) = {14042, 14014};

//Surface outer box
Line Loop(2025) = {2013, -2019, -2018, -2017};
Plane Surface(2025) = {2025};
Line Loop(2026) = {2015, 2023, 2021, 2022};
Plane Surface(2026) = {2026};
Line Loop(2027) = {2016, 2017, 2020, -2023};
Plane Surface(2027) = {2027};
Line Loop(2028) = {2016, 2013, 2014, 2015};
Plane Surface(2028) = {2028};
Line Loop(2029) = {2014, -2022, 2024, 2019};
Plane Surface(2029) = {2029};
Line Loop(2030) = {2020, 2021, 2024, -2018};
Plane Surface(2030) = {2030};

//Inner box.
Line Loop(2031) = {5025, 5026, 5027, 5028, -14005, -14008, -14007, -14006};
Plane Surface(2031) = {2031};
Line Loop(2032) = {5025, 5031, 5032, 5033};
Plane Surface(2032) = {2032};
Line Loop(2033) = {5032, 5036, 5037, 5038};
Plane Surface(2033) = {2033};
Line Loop(2034) = {5027, 5041, 5037, 5043};
Plane Surface(2034) = {2034};
Line Loop(2035) = {5026, -5043, 5038, -5031};
Plane Surface(2035) = {2035};
Line Loop(2036) = {5028, -5033, 5036, -5041};
Plane Surface(2036) = {2036};

//Surface SC
Line Loop(3047) = {3025, 3021, 3022, 3023, 3024};
Plane Surface(3047) = {3047};
Line Loop(3049) = {3041, 3042, 3043, 3044, 3045};
Plane Surface(3049) = {3049};
Line Loop(3051) = {3020, -3029, -3008, 3024};
Ruled Surface(3051) = {3051};
Line Loop(3053) = {3020, 3030, -3001, -3025};
Ruled Surface(3053) = {3053};
Line Loop(3055) = {3026, -3016, -3021, 3001};
Ruled Surface(3055) = {3055};
Line Loop(3057) = {3016, 3027, -3012, -3022};
Ruled Surface(3057) = {3057};
Line Loop(3059) = {3012, 3028, -3008, -3023};
Ruled Surface(3059) = {3059};
Line Loop(3061) = {3034, -3019, -3029, 3007};
Ruled Surface(3061) = {3061};
Line Loop(3063) = {3035, -3002, -3030, 3019};
Ruled Surface(3063) = {3063};
Line Loop(3065) = {3031, -3015, -3026, 3002};
Ruled Surface(3065) = {3065};
Line Loop(3067) = {3015, 3032, -3011, -3027};
Ruled Surface(3067) = {3067};
Line Loop(3069) = {3028, 3007, -3033, -3011};
Ruled Surface(3069) = {3069};
Line Loop(3071) = {3003, 3036, -3014, -3031};
Ruled Surface(3071) = {3071};
Line Loop(3073) = {3014, 3037, -3010, -3032};
Ruled Surface(3073) = {3073};
Line Loop(3075) = {3010, 3038, -3006, -3033};
Ruled Surface(3075) = {3075};
Line Loop(3077) = {3006, 3039, -3018, -3034};
Ruled Surface(3077) = {3077};
Line Loop(3079) = {3018, 3040, -3003, -3035};
Ruled Surface(3079) = {3079};
Line Loop(3081) = {3004, 3041, -3013, -3036};
Ruled Surface(3081) = {3081};
Line Loop(3083) = {3042, -3009, -3037, 3013};
Ruled Surface(3083) = {3083};
Line Loop(3085) = {3043, -3005, -3038, 3009};
Ruled Surface(3085) = {3085};
Line Loop(3087) = {3039, 3017, -3044, -3005};
Ruled Surface(3087) = {3087};
Line Loop(3099) = {3090, 3091, 3092, 3093};
Plane Surface(3099) = {3099};
Line Loop(5010) = {5006, -5005, -5001};
Ruled Surface(5010) = {5010};
Line Loop(5012) = {5005, -5008, -5002};
Ruled Surface(5012) = {5012};
Line Loop(5014) = {5008, -5007, -5003};
Ruled Surface(5014) = {5014};
Line Loop(5016) = {5007, -5006, -5004};
Ruled Surface(5016) = {5016};
Line Loop(5018) = {5004, 5001, 5002, 5003};
Plane Surface(5018) = {5018};
Line Loop(90008) = {3092, 90006, 14006, -90003};
Plane Surface(90008) = {90008};
Line Loop(90010) = {90003, 14007, -90004, 3091};
Plane Surface(90010) = {90010};
Line Loop(90012) = {3090, 90004, 14008, -90005};
Plane Surface(90012) = {90012};
Line Loop(90014) = {90005, 14005, -90006, 3093};
Plane Surface(90014) = {90014};
Line Loop(90016) = {3096, -14005, 3095, -3040};
Plane Surface(90016) = {90016};
Line Loop(90018) = {14006, 3097, -3017, 3096};
Plane Surface(90018) = {90018};
Line Loop(90020) = {14007, -3094, -3045, -3097};
Plane Surface(90020) = {90020};
Line Loop(90022) = {3094, 14008, 3095, 3004};
Plane Surface(90022) = {90022};

//Interm. box
Line Loop(90027) = {90028, 90029, 90030, 90031};
Plane Surface(90027) = {90027};
Line Loop(90032) = {90029, 90034, 90035, 90036};
Plane Surface(90032) = {90032};
Line Loop(90037) = {90038, 90039, 90040, 90035};
Plane Surface(90037) = {90037};
Line Loop(90042) = {90031, 90044, 90039, 90046};
Plane Surface(90042) = {90042};
Line Loop(90047) = {90028, -90036, 90038, -90044};
Plane Surface(90047) = {90047};
Line Loop(90052) = {90030, -90046, 90040, -90034};
Plane Surface(90052) = {90052};

//Volume
//Inner box except SC, Antenna, Bom of LP
Surface Loop(90053) = {2031, 2032, 2035, 2034, 2036, 2033, 3051, 3053, 3063, 3079, 3077, 3075, 3073, 3071, 3081, 90022, 90020, 3049, 3083, 3085, 3087, 90018, 90016, 3065, 3067, 3069, 3059, 3057, 3055, 3047, 3061};
Surface Loop(90054) = {5010, 5016, 5014, 5012, 5018};
Volume(90055) = {90053, 90054, 7039};
//Interm. box except inner box and bom
Surface Loop(90056) = {90027, 90047, 90032, 90052, 90042, 90037};
Surface Loop(90057) = {90012, 3099, 90010, 90008, 90014, 2031, 2032, 2035, 2034, 2036, 2033};
Volume(90058) = {90056, 90057};
//Outer box except interm. box
Surface Loop(90059) = {2028, 2027, 2025, 2029, 2026, 2030};
Volume(90060) = {90059, 90056};


//Physical
//Outer boundary surface
Physical Surface(2001) = {2025, 2026, 2027, 2028, 2029, 2030};
//SC surface
Physical Surface(3002) = {3047, 3049, 3051, 3053, 3055, 3057, 3059, 3061, 3063, 3065, 3067, 3069, 3071, 3073, 3075, 3077, 3079, 3081, 3083, 3085, 3087, 3099, 5010, 5012, 5014, 5016, 5018, 7038, 7023, 7013, 7033, 7028, 7018, 90008, 90010, 90012, 90014, 90016, 90018, 90020, 90022};

//Mesh bom to LP
Physical Surface(90001) = {7001, 7002, 7003, 7004, 7005, 7006};
//Inner box
Physical Surface(90002) = {2031, 2032, 2033, 2034, 2035, 2036};
//Interm. box
Physical Surface(90003) = {90027, 90032, 90037, 90042, 90047, 90052};
//Total volume
Physical Volume(6001) = {7001, 90055, 90058, 90060};
