////////////////////////////////////////////////
// Copyright Thomas Nilsson                   //
//                                            //
////////////////////////////////////////////////
//         Parameters for the mesh            //
////////////////////////////////////////////////

cl_probe = 0.005;
cl_inner = 0.01;
cl_intermid = 0.07;
cl_boundary = 0.4;


////////////////////////////////////////////////
//         Points for LP with stub            //
////////////////////////////////////////////////

Point(1) = {0.209, 0, 0, cl_probe};
Point(2) = {0.234, 0, 0, cl_probe};
Point(3) = {0.259, 0, 0, cl_probe};
Point(4) = {0.209202432074906, 0, 0.00317500000005611, cl_probe};
Point(5) = {0.209202432074906, 0, -0.00317500000005611, cl_probe};
Point(6) = {0.209202432074906, 0.00317500000005611, 0, cl_probe};
Point(7) = {0.209202432074906, -0.00317500000005611, 0, cl_probe};
Point(8) = {0.234, 0, 0.025, cl_probe};
Point(9) = {0.234, 0, -0.025, cl_probe};
Point(10) = {0.234, -0.025, 0, cl_probe};
Point(11) = {0.234, 0.025, 0, cl_probe};
Point(12) = {0.209202432074906, 0, 0, cl_probe};
Point(13) = {0.1, 0, -0.003175, cl_probe};
Point(14) = {0.1, 0, 0, cl_probe};
Point(15) = {0.1, 0.003175, 0, cl_probe};
Point(16) = {0.1, 0, 0.003175, cl_probe};
Point(17) = {0.1, -0.003175, 0, cl_probe};


////////////////////////////////////////////////
//         Points for inner volume            //
////////////////////////////////////////////////

Point(18) = {0.1, 0.05, 0, cl_inner};
Point(19) = {0.1, -0.05, 0, cl_inner};
Point(20) = {0.1, 0, 0.05, cl_inner};
Point(21) = {0.1, 0, -0.05, cl_inner};
Point(22) = {0.309, 0, 0.05, cl_inner};
Point(23) = {0.309, 0, 0, cl_inner};
Point(24) = {0.309, 0.05, 0, cl_inner};
Point(25) = {0.309, -0.05, 0, cl_inner};
Point(26) = {0.309, 0, -0.05, cl_inner};


////////////////////////////////////////////////
//         Points interface between parts     //
//         of stub in and out of shade.       //
//         For future use only                //
////////////////////////////////////////////////

Point(27) = {0.160905, 0, 0, cl_probe};
Point(28) = {0.160905, 0, -0.003175, cl_probe};
Point(29) = {0.160905, 0.003175, 0, cl_probe};
Point(30) = {0.160905, 0, 0.003175, cl_probe};
Point(31) = {0.160905, -0.003175, 0, cl_probe};


////////////////////////////////////////////////
//         Points for intermediate volume     //
////////////////////////////////////////////////

Point(32) = {-0.2, 0, 0, cl_intermid};
Point(33) = {-0.2, 0.225, 0, cl_intermid};
Point(34) = {-0.2, -0.225, 0, cl_intermid};
Point(35) = {-0.2, 0, 0.225, cl_intermid};
Point(36) = {-0.2, 0, -0.225, cl_intermid};
Point(37) = {0.459, 0, 0.225, cl_intermid};
Point(38) = {0.459, 0, 0, cl_intermid};
Point(39) = {0.459, 0.225, 0, cl_intermid};
Point(40) = {0.459, -0.225, 0, cl_intermid};
Point(41) = {0.459, 0, -0.225, cl_intermid};


////////////////////////////////////////////////
//         Points for outer boundary          //
////////////////////////////////////////////////

Point(42) = {-0.3, 0, 0, cl_boundary};
Point(43) = {-0.3, 1.025, 0, cl_boundary};
Point(44) = {-0.3, -1.025, 0, cl_boundary};
Point(45) = {-0.3, 0, 1.025, cl_boundary};
Point(46) = {-0.3, 0, -1.025, cl_boundary};
Point(47) = {1.259, 0, 1.025, cl_boundary};
Point(48) = {1.259, 0, 0, cl_boundary};
Point(49) = {1.259, 1.025, 0, cl_boundary};
Point(50) = {1.259, -1.025, 0, cl_boundary};
Point(51) = {1.259, 0, -1.025, cl_boundary};


////////////////////////////////////////////////
//         Circles and lines                  //
////////////////////////////////////////////////

Circle (1) = {3, 2, 8};
Circle (2) = {5, 2, 9};
Circle (3) = {9, 2, 3};
Circle (4) = {3, 2, 10};
Circle (5) = {9, 2, 10};
Circle (6) = {10, 2, 8};
Circle (7) = {8, 2, 11};
Circle (8) = {11, 2, 9};
Circle (9) = {3, 2, 11};
Circle (10) = {11, 2, 6};
Circle (11) = {7, 2, 10};
Circle (12) = {8, 2, 4};
Circle (13) = {6, 12, 4};
Circle (14) = {4, 12, 7};
Circle (15) = {7, 12, 5};
Circle (16) = {5, 12, 6};
Circle (17) = {13, 14, 15};
Circle (18) = {15, 14, 16};
Circle (19) = {16, 14, 17};
Circle (20) = {17, 14, 13};
Line (21) = {15, 29};
Line (22) = {13, 28};
Line (23) = {17, 31};
Line (24) = {30, 16};
Circle (25) = {18, 14, 21};
Circle (26) = {21, 14, 19};
Circle (27) = {19, 14, 20};
Circle (28) = {20, 14, 18};
Circle (29) = {22, 23, 24};
Circle (30) = {25, 23, 22};
Circle (31) = {24, 23, 26};
Circle (32) = {26, 23, 25};
Line (33) = {26, 21};
Line (34) = {18, 24};
Line (35) = {22, 20};
Line (36) = {19, 25};
Circle (37) = {28, 27, 29};
Circle (38) = {29, 27, 30};
Circle (39) = {30, 27, 31};
Circle (40) = {31, 27, 28};
Line (41) = {29, 6};
Line (42) = {28, 5};
Line (43) = {31, 7};
Line (44) = {4, 30};
Circle (45) = {33, 32, 36};
Circle (46) = {36, 32, 34};
Circle (47) = {34, 32, 35};
Circle (48) = {35, 32, 33};
Circle (49) = {37, 38, 40};
Circle (50) = {40, 38, 41};
Circle (51) = {41, 38, 39};
Circle (52) = {39, 38, 37};
Line (53) = {36, 41};
Line (54) = {34, 40};
Line (55) = {35, 37};
Line (56) = {33, 39};
Circle (57) = {43, 42, 46};
Circle (58) = {46, 42, 44};
Circle (59) = {44, 42, 45};
Circle (60) = {45, 42, 43};
Circle (61) = {47, 48, 50};
Circle (62) = {50, 48, 51};
Circle (63) = {51, 48, 49};
Circle (64) = {49, 48, 47};
Line (65) = {46, 51};
Line (66) = {44, 50};
Line (67) = {45, 47};
Line (68) = {43, 49};


////////////////////////////////////////////////
//         Surfaces                           //
////////////////////////////////////////////////

Line Loop (1) = {40, -22, -20, 23};
Ruled Surface (1) = {1};
Line Loop (2) = {22, 37, -21, -17};
Ruled Surface (2) = {2};
Line Loop (3) = {38, 24, -18, 21};
Ruled Surface (3) = {3};
Line Loop (4) = {23, -39, 24, 19};
Ruled Surface (4) = {4};
Line Loop (5) = {15, 2, 5, -11};
Ruled Surface (5) = {5};
Line Loop (6) = {2, -8, 10, -16};
Ruled Surface (6) = {6};
Line Loop (7) = {11, 6, 12, 14};
Ruled Surface (7) = {7};
Line Loop (8) = {10, 13, -12, 7};
Ruled Surface (8) = {8};
Line Loop (9) = {1, 7, -9};
Ruled Surface (9) = {9};
Line Loop (10) = {1, -6, -4};
Ruled Surface (10) = {10};
Line Loop (11) = {4, -5, 3};
Ruled Surface (11) = {11};
Line Loop (12) = {3, 9, 8};
Ruled Surface (12) = {12};
Line Loop (13) = {29, 31, 32, 30};
Plane Surface (13) = {13};
Line Loop (14) = {29, -34, -28, -35};
Ruled Surface (14) = {14};
Line Loop (15) = {35, -27, 36, 30};
Ruled Surface (15) = {15};
Line Loop (16) = {36, -32, 33, 26};
Ruled Surface (16) = {16};
Line Loop (17) = {34, 31, 33, -25};
Ruled Surface (17) = {17};
Line Loop (18) = {13, 44, -38, 41};
Ruled Surface (18) = {18};
Line Loop (19) = {14, -43, -39, -44};
Ruled Surface (19) = {19};
Line Loop (20) = {15, -42, -40, 43};
Ruled Surface (20) = {20};
Line Loop (21) = {16, -41, -37, 42};
Ruled Surface (21) = {21};
Line Loop (22) = {46, 47, 48, 45};
Plane Surface (22) = {22};
Line Loop (23) = {50, 51, 52, 49};
Plane Surface (23) = {23};
Line Loop (24) = {53, 51, -56, 45};
Ruled Surface (24) = {24};
Line Loop (25) = {56, 52, -55, 48};
Ruled Surface (25) = {25};
Line Loop (26) = {49, -54, 47, 55};
Ruled Surface (26) = {26};
Line Loop (27) = {50, -53, 46, 54};
Ruled Surface (27) = {27};
Line Loop (28) = {58, 59, 60, 57};
Plane Surface (28) = {28};
Line Loop (29) = {62, 63, 64, 61};
Plane Surface (29) = {29};
Line Loop (30) = {65, 63, -68, 57};
Ruled Surface (30) = {30};
Line Loop (31) = {68, 64, -67, 60};
Ruled Surface (31) = {31};
Line Loop (32) = {61, -66, 59, 67};
Ruled Surface (32) = {32};
Line Loop (33) = {62, -65, 58, 66};
Ruled Surface (33) = {33};
Line Loop (34) = {18, 19, 20, 17};
Plane Surface (34) = {34};
Line Loop (35) = {25, 26, 27, 28, 20, 17, 18, 19};
Plane Surface (35) = {35};


////////////////////////////////////////////////
//         Volumes                            //
////////////////////////////////////////////////

// Inner volume, excluding the LP with sphere and stub
Surface Loop (1) = {14, 13, 17, 16, 15, 35, 6, 5, 20, 21, 18, 8, 7, 10, 9, 12, 11, 19, 4, 1, 2, 3};
Volume (1) = {1};

// Intermediate volume, excluding inner volume
Surface Loop (2) = {26, 23, 27, 24, 25, 22, 35, 17, 14, 13, 16, 15, 34};
Volume (2) = {2};

// Outer volume, excluding intermediate volume
Surface Loop (3) = {32, 29, 33, 30, 31, 28, 26, 23, 27, 24, 25, 22};
Volume (3) = {3};


////////////////////////////////////////////////
//     Physicals to be used by SPIS           //
////////////////////////////////////////////////

// Outer boundary, ID = 2001
Physical Surface (2001) = {28, 29, 30, 31, 32, 33};

// LP sphere, ID = 3001
Physical Surface (3001) = {5, 6, 7, 8, 9, 10, 11, 12};

// LP stub, ID = 3002
Physical Surface (3002) = {1, 2, 3, 4, 18, 19, 20, 21};

// LP bottom of stub, ID = 3003
Physical Surface (3003) = {34};

// Plasma volume, ID = 6001
Physical Volume (6001) = {1, 2, 3};